program Focus_1D

  use sep
  use mem_mod
  use focus1D_mod
  use Util1D_mod

  implicit none

  logical, parameter                  :: T = .true., F = .false.
  logical                             :: adj,add=F,verb
  logical                             :: use_focus_oper,focus_complement
  logical                             :: shrink

  integer                             :: lag_n,slow_n,i_slow,interp_n
  integer                             :: zero_lag,slow_phys_lag
  integer                             :: focus_oper_n,focus_oper_i

  real                                :: lag_d,lag_o,slow_o,slow_d
  real                                :: focus_oper_o,focus_oper_d
  real                                :: focus_strength

  real, dimension(:), allocatable     :: slow_in,slow_out

  integer(kind=8)                     :: timer0, timer1, rate
  real                                :: timer_sum

  call sep_init()

!---------------------------------------------------------------------------
  call system_clock(timer0, rate)
!---------------------------------------------------------------------------

  call from_param("use_focus_oper", use_focus_oper, .false.)
  call from_param("focus_complement", focus_complement, .true.)
  call from_param("shrink",shrink, .false.)
  call from_param("focus_strength", focus_strength, .0001)
  call from_param("interp_n", interp_n, 9)

  call get_process_param(verb,adj)
  call get_slow_param(lag_n,lag_o,lag_d,slow_phys_lag,zero_lag, &
         slow_n,slow_o,slow_d,"in") 
  if(use_focus_oper) then
    call get_focus_oper_param( &
       focus_oper_n,focus_oper_o,focus_oper_d,"focus_oper")
       if((focus_oper_n .ne. 1) .and. (slow_n .ne. focus_oper_n)) &
           call seperr("slow_n .ne. focus_oper_n and focus_oper_n ne 1")
    else
       focus_oper_n=1
       focus_oper_o=0.
       focus_oper_d=1.
  end if
  call header_to_slow(lag_n,slow_n,lag_o,slow_o,lag_d,slow_d,"out") 

  call focus1D_init(verb,use_focus_oper,focus_complement,shrink, &
         lag_n,slow_phys_lag,zero_lag,lag_o,lag_d, &
         focus_oper_n,focus_oper_o,focus_oper_d, &
         interp_n,focus_strength)

  call mem_alloc(slow_in, lag_n)
  call mem_alloc(slow_out, lag_n)

  do i_slow=1,slow_n
  !{
    write(0,*) "i_slow=",i_slow
    call focus1D_oper_update2(i_slow)
    if(adj) then
      call sep_read(slow_out)
    else
      call sep_read(slow_in)
    end if
    call focus1D_op2(adj, add, slow_in, slow_out)
    if(adj) then
      call sep_write(slow_in)
    else
      call sep_write(slow_out)
    end if
  !}
  end do
!---------------------------------------------------------------------------
  call system_clock(timer1)
  timer_sum = 1.*(timer1-timer0)/rate
  call to_history("timer sum (min)", timer_sum/60.)
  write(0,*) "timer sum (min)", timer_sum/60.
!---------------------------------------------------------------------------

end program
