Program Fwi_Dat_res

  use sep
  use axis_mod
  use mem_mod
  use Util1Daxis_mod
  use prop1Daxis_mod

  type(axis)    :: atau, adat, awav
  integer :: nm, nd, nw, niter
  integer :: iter, stat
  real              :: dist, dly
  real, allocatable :: mdls(:)
  real, allocatable :: rdat(:), mdat(:), res(:)
  real, allocatable :: wav(:)
  real, allocatable :: nrm(:)

  call sep_init()

  call from_param("dist", dist, 2.0)

  call get_wavelet_axis(awav, dly, "wav")
  adat = get_data_axis("data")
  atau = get_slow_axis("in")
  call hetch("n2","d",niter)

  nm = atau%n; nd = adat%n; nw = awav%n

  call mem_alloc(mdls, nm)
  call mem_alloc(rdat, nd)
  call mem_alloc(mdat, nd)
  call mem_alloc(res,  nd)
  call mem_alloc(wav, nw)
  call mem_alloc(nrm, niter)

  call sreed("data", rdat , 4 * nd)
  call sreed("wav" , wav  , 4 * nw)

  call prop1Daxis_init(adat, awav, dly, dist)
  stat = prop1Daxis_wavelet_update(wav)

  do iter = 1, niter
    call sreed("in", mdls, 4 * nm)
    stat = prop1Daxis_nlop(.false., .false., mdls, mdat)
    res = mdat - rdat
    nrm(iter) = 0.5*dot_product(res, res)
  enddo

  call putch("n1", "d", niter)
  call putch("n2", "d", 1)
  call putch("o1", "f", 0.0)
  call putch("d1", "f", 1.0)
  call srite("out", nrm, 4*niter)

  call mem_dealloc(mdls); call mem_dealloc(rdat)
  call mem_dealloc(mdat); call mem_dealloc(res)
  call mem_dealloc(nrm)

end program
