Program Modnorm
  !
  ! Modnorm  ||model (iter) - model (niter)||

  use sep

  implicit none               
  integer                            :: n1, n2, n3, i
  real                               :: stru
  real, dimension (:,:), allocatable :: modl
  real, dimension (:), allocatable   :: norm, diff
  character(1)                       :: ntype

  call sep_init ()

  ! Get params
  call from_param("type", ntype, 't')
  call from_param("stru", stru,  1.0)
 
  ! Get axes
  call from_history ("n1",n1)
  call from_history ("n2",n2)
  call to_history   ("n1",n2)
  call to_history   ("o1",0.0)
  call to_history   ("d1",1.0)
  call to_history   ("n2",1)

  allocate (modl(n1,n2))
  allocate (norm(n2))
  allocate (diff (n1))

  call sep_read (modl)

  diff = 0
  do i = 1, n2
    if(ntype == 't') then
      diff = modl (:,i) - modl (:,n2)
    else if(ntype == 'c') then
      diff = modl (1:n1-1,i) - modl (1-n1-1:,n2)
    else if(ntype == 's') then
      diff = modl (n1,i) - stru
    else
      call seperr("Type not recognized. Please enter 't', 's', or 'c'")
    endif
    norm (i) = sqrt (dot_product (diff, diff))
    if(ntype == 's') then
      norm(i) = abs(diff(n1))
    endif
  end do

  call  sep_write (norm)
  deallocate (modl, norm, diff)  
  call exit (0)
end Program

