program Prop_1D

  use sep
  use mem_mod
  use prop1D_mod
  use Util1D_mod

  implicit none

  logical, parameter                  :: T = .true., F = .false.
  logical                             :: adj,add=F,verb,all_back_slow
  logical                             :: const_back_slow
  integer                             :: t_n,wavelet_n
  integer                             :: lag_n,slow_n,i_slow,i_back_trial
  integer                             :: loop_trial_slow_n
  integer                             :: zero_lag,slow_phys_lag
  integer                             :: ret_seek,sseek

  real                                :: lag_d,lag_o,slow_o,slow_d
  real                                :: slow_o_test,slow_d_test
  real                                :: wavelet_o,wavelet_d,t_o,t_d
  real                                :: wavelet_tdelay
  real                                :: slow_phys,trial_slow_phys,prop_dist

  real, dimension(:), allocatable     :: slow
  real, dimension(:), allocatable     :: data,wavelet

  integer(kind=8)                     :: timer0, timer1, rate
  real                                :: timer_sum

  call sep_init()

!---------------------------------------------------------------------------
  call system_clock(timer0, rate)
!---------------------------------------------------------------------------

  call from_param("all_back_slow", all_back_slow, .false.)
  call from_param("const_back_slow", const_back_slow, .false.)
  call get_process_param(verb,adj)
  call get_acq_param(prop_dist)
  call get_back_slow_param(lag_n,lag_o,lag_d, &
        slow_phys_lag,zero_lag, &
        slow_n,slow_o,slow_d,"Slow") 

  if(adj) then
    call get_data_param(t_n,t_o,t_d,slow_n,slow_o,slow_d,"in")
!    if(slow_n .ne. slow_n_test) call seperr("slow_n /= slow_n_test in data")
!    if(slow_o .ne. slow_o_test) call seperr("slow_o /= slow_o_test in data")
!    if(slow_d .ne. slow_d_test) call seperr("slow_d /= slow_d_test in data")
    call get_wavelet_param(wavelet_n,wavelet_o,wavelet_d,wavelet_tdelay)
    call header_to_wavelet(wavelet_n,slow_n,wavelet_o,slow_o,wavelet_d,slow_d,"out") 
  else
!write(0,*)'Before'
    call get_data_param(t_n,t_o,t_d)
    call get_wavelet_param(wavelet_n,wavelet_o,wavelet_d,wavelet_tdelay,"in")
    call header_to_data(t_n,slow_n,t_o,slow_o,t_d,slow_d,"out")
!write(0,*)'After'
  end if
  if(all_back_slow) then
    call to_history("n3", slow_n, "out")
    call to_history("o3", slow_o, "out")
    call to_history("d3", slow_d, "out")
    call to_history("label3", "Trial Slowness (s/km)", "out")
  end if

  call prop1D_init(t_n,wavelet_n,lag_n,lag_o,lag_d, &
      wavelet_o,wavelet_d,t_o,t_d,wavelet_tdelay,prop_dist)

  call mem_alloc(slow, lag_n)
  call mem_alloc(data, t_n)
  call mem_alloc(wavelet, wavelet_n)

  if(all_back_slow) then
    loop_trial_slow_n=slow_n
  else
    loop_trial_slow_n=1
  end if
   write(0,*)'loop_trial_slow_n=',loop_trial_slow_n

  do i_back_trial=1,loop_trial_slow_n
  !{
    ret_seek=sseek("in",0,0)
    ret_seek=sseek("Slow",0,0)
    trial_slow_phys=slow_o + (i_back_trial-1)*slow_d
    do i_slow=1,slow_n
    !{
      call sep_read(slow,"Slow")
      if(all_back_slow) then
        if(const_back_slow) then
          slow_phys=slow(lag_n)
          slow_phys=slow(slow_phys_lag)
        else
          slow_phys=trial_slow_phys
        end if
      else
        slow_phys=slow(slow_phys_lag)
      end if
      call prop1D_slow_update2(slow_phys)
      if(verb) write(0,*) "i_slow=",i_slow,"slow_phy=",slow_phys

      if(adj) then
        call sep_read(data)
      else
        call sep_read(wavelet)
      end if
      call prop1D_op2(adj, add, wavelet, data)
      if(adj) then
        call sep_write(wavelet)
      else
        call sep_write(data)
      end if
    !}
    end do
  !}
  end do
!---------------------------------------------------------------------------
  call system_clock(timer1)
  timer_sum = 1.*(timer1-timer0)/rate
  call to_history("timer sum (min)", timer_sum/60.)
  write(0,*) "timer sum (min)", timer_sum/60.
!---------------------------------------------------------------------------

end program
