program Prop_1D

  use sep
  use axis_mod
  use mem_mod
  use prop1Daxis_mod
  use Util1Daxis_mod

  implicit none

  logical, parameter                  :: T = .true., F = .false.
  type(axis)                          :: adat, awav, aslw
  logical                             :: adj,add=F,verb
  integer                             :: i_slow

  real                                :: dly
  real                                :: slow_phys,dist

  real, dimension(:), allocatable     :: slow
  real, dimension(:), allocatable     :: data,wavelet

  integer(kind=8)                     :: timer0, timer1, rate
  real                                :: timer_sum

  call sep_init()

!---------------------------------------------------------------------------
  call system_clock(timer0, rate)
!---------------------------------------------------------------------------

  call from_param("dist", dist, 2.0)
  call from_param("verb", verb, .false.)
  call from_param("adj" , adj,  .false.)

  aslw = get_backslow_axis()

  if(adj) then
    adat = get_data_axis("in")
    call get_wavelet_axis(awav,dly)
    call put_wavelet_axis(awav,"out",aslw)
  else
    adat = get_data_axis()
    call get_wavelet_axis(awav,dly,"in")
    call put_data_axis(adat, "out", aslw)
  end if

  call prop1Daxis_init(adat, awav, dly, dist)

  call mem_alloc(data, adat%n)
  call mem_alloc(wavelet, awav%n)

  do i_slow=1,aslw%n
  !{
    slow_phys = aslw%o + aslw%d * (i_slow - 1)
    call prop1Daxis_slow_update2(slow_phys)
    if(verb) write(0,*) "i_slow=",i_slow,"slow_phy=",slow_phys
    if(adj) then
      call sep_read(data)
    else
      call sep_read(wavelet)
    end if
    call prop1Daxis_op2(adj, add, wavelet, data)
    if(adj) then
      call sep_write(wavelet)
    else
      call sep_write(data)
    end if

  !}
  end do
!---------------------------------------------------------------------------
  call system_clock(timer1)
  timer_sum = 1.*(timer1-timer0)/rate
  call to_history("timer sum (min)", timer_sum/60.)
  write(0,*) "timer sum (min)", timer_sum/60.
!---------------------------------------------------------------------------

end program
