program Prop_der1_1D

  use sep
  use mem_mod
  use prop_der11D_mod
  use Util1D_mod

  implicit none

  logical, parameter                  :: T = .true., F = .false.
  logical                             :: adj,add=F,verb
  integer                             :: t_n,wavelet_n
  integer                             :: lag_n,slow_n,i_slow,slow_n_test
  integer                             :: zero_lag,slow_phys_lag

  real                                :: lag_d,lag_o,slow_o,slow_d
  real                                :: slow_o_test,slow_d_test
  real                                :: wavelet_o,wavelet_d,t_o,t_d
  real                                :: wavelet_tdelay
  real                                :: slow_phys,prop_dist

  real, dimension(:), allocatable     :: back_slow
  real, dimension(:), allocatable     :: data,model,wavelet

  integer(kind=8)                     :: timer0, timer1, rate
  real                                :: timer_sum

  call sep_init()

!---------------------------------------------------------------------------
  call system_clock(timer0, rate)
!---------------------------------------------------------------------------

  call get_process_param(verb,adj)
  call get_acq_param(prop_dist)
  call get_back_slow_param(lag_n,lag_o,lag_d, &
        slow_phys_lag,zero_lag, &
        slow_n,slow_o,slow_d,"Slow") 
  call get_wavelet_param(wavelet_n,wavelet_o,wavelet_d,wavelet_tdelay,"Wavelet")

  if(adj) then
    call get_data_param(t_n,t_o,t_d,slow_n_test,slow_o_test,slow_d_test,"in")
    if(slow_n .ne. slow_n_test) call seperr("slow_n /= slow_n_test in input")
    if(slow_o .ne. slow_o_test) call seperr("slow_o /= slow_o_test in input")
    if(slow_d .ne. slow_d_test) call seperr("slow_d /= slow_d_test in input")
!    call get_slow_param(lag_n,lag_o,lag_d,slow_phys_lag,zero_lag) 
    call header_to_slow(lag_n,slow_n,lag_o,slow_o,lag_d,slow_d,"out") 
  else
    call get_slow_param(lag_n,lag_o,lag_d,slow_phys_lag,zero_lag, &
        slow_n_test,slow_o_test,slow_d_test,"in") 
    if(slow_n .ne. slow_n_test) call seperr("slow_n /= slow_n_test in input")
    if(slow_o .ne. slow_o_test) call seperr("slow_o /= slow_o_test in input")
    if(slow_d .ne. slow_d_test) call seperr("slow_d /= slow_d_test in input")
    call get_data_param(t_n,t_o,t_d)
    call header_to_data(t_n,slow_n,t_o,slow_o,t_d,slow_d,"out")
  end if

  call prop_der11D_init(t_n,wavelet_n,lag_n,lag_o,lag_d, &
      wavelet_o,wavelet_d,t_o,t_d,wavelet_tdelay,prop_dist)

  call mem_alloc(wavelet, wavelet_n)
  call sep_read(wavelet,"Wavelet")
  call prop_der11D_der1_wavelet_update2(wavelet)

  call mem_alloc(back_slow, lag_n)
  call mem_alloc(data, t_n)
  call mem_alloc(model, lag_n)

  do i_slow=1,slow_n
  !{
    call sep_read(back_slow,"Slow")
    slow_phys=back_slow(lag_n)
    call prop_der11D_phys_slow_update2(slow_phys)
    if(verb) write(0,*) "i_slow=",i_slow,"slow_phy=",slow_phys
    if(adj) then
      call sep_read(data)
    else
      call sep_read(model)
    end if
    call prop_der11D_op2(adj, add, model, data)
    if(adj) then
      call sep_write(model)
    else
      call sep_write(data)
    end if

  !}
  end do
!---------------------------------------------------------------------------
  call system_clock(timer1)
  timer_sum = 1.*(timer1-timer0)/rate
  call to_history("timer sum (min)", timer_sum/60.)
  write(0,*) "timer sum (min)", timer_sum/60.
!---------------------------------------------------------------------------

end program
