program Prop_extend_1D

  use sep
  use mem_mod
  use prop_extend1D_mod
  use Util1D_mod

  implicit none

  logical, parameter                  :: T = .true., F = .false.
  logical                             :: adj,add=F,verb,all_back_slow
  logical                             :: const_back_slow
  integer                             :: t_n,wavelet_n
  integer                             :: lag_n,slow_n,i_slow,i_back_trial
  integer                             :: back_lag_n,back_slow_n,loop_trial_slow_n
  integer                             :: zero_lag,slow_phys_lag
  integer                             :: back_zero_lag,back_slow_phys_lag
  integer                             :: ret_seek,sseek

  real                                :: lag_d,lag_o,slow_o,slow_d
  real                                :: back_lag_d,back_lag_o
  real                                :: back_slow_o,back_slow_d
  real                                :: wavelet_o,wavelet_d,t_o,t_d
  real                                :: wavelet_tdelay
  real                                :: slow_phys,trial_slow_phys,prop_dist
  real, dimension(:), allocatable     :: slow,back_slow,wavelet
  real, dimension(:), allocatable     :: data

  integer(kind=8)                     :: timer0, timer1, rate
  real                                :: timer_sum

  call sep_init()

!---------------------------------------------------------------------------
  call system_clock(timer0, rate)
!---------------------------------------------------------------------------

  call from_param("all_back_slow", all_back_slow, .false.)
  call from_param("const_back_slow", const_back_slow, .false.)
  call get_process_param(verb,adj)
  call get_acq_param(prop_dist)
  call get_back_slow_param(back_lag_n,back_lag_o,back_lag_d, &
         back_slow_phys_lag,back_zero_lag, &
         back_slow_n,back_slow_o,back_slow_d,"Slow")
  call get_wavelet_param(wavelet_n,wavelet_o,wavelet_d,wavelet_tdelay,"Wavelet")

  if(adj) then
    call get_data_param(t_n,t_o,t_d,slow_n,slow_o,slow_d,"in")
!    if(slow_n .ne. slow_n_test) call seperr("slow_n /= slow_n_test in data")
!    if(slow_o .ne. slow_o_test) call seperr("slow_o /= slow_o_test in data")
!    if(slow_d .ne. slow_d_test) call seperr("slow_d /= slow_d_test in data")
    call get_slow_param(lag_n,lag_o,lag_d,slow_phys_lag,zero_lag) 
    call header_to_slow(lag_n,slow_n,lag_o,slow_o,lag_d,slow_d,"out") 
    if(lag_d .ne. t_d) call seperr("lag_d /= t_d in data and parmeters")
  else
!write(0,*)'t_d=',t_d
    call get_slow_param(lag_n,lag_o,lag_d,slow_phys_lag,zero_lag, &
        slow_n,slow_o,slow_d,"in") 
!    if(slow_o_back.ne.slow_o_test) call seperr("slow_o_back /= slow_o_test")
!    if(slow_d _back.ne.slow_d_test) call seperr("slow_d_back /= slow_d_test")
!    if(slow_d _back.ne.slow_d_test) call seperr("slow_d_back /= slow_d_test")
    call get_data_param(t_n,t_o,t_d)
    call header_to_data(t_n,slow_n,t_o,slow_o,t_d,slow_d,"out")
  end if
  if(all_back_slow) then
    call to_history("n3", back_slow_n, "out")
    call to_history("o3", back_slow_o, "out")
    call to_history("d3", back_slow_d, "out")
    call to_history("label3", "Trial Slowness (s/km)", "out")
  end if

  if(back_lag_n .ne. 1) call erexit("In Slow lag_n .ne. 1")
  if(slow_n .ne. back_slow_n) call erexit("slow_n .ne. back_slow_n")
  if(slow_o .ne. back_slow_o) call erexit("slow_o .ne. back_slow_o")
  if(slow_d .ne. back_slow_d) call erexit("slow_d .ne. back_slow_d")

  call prop_extend1D_init(t_n,wavelet_n,lag_n,lag_o,lag_d, &
      back_lag_n,back_lag_o,back_lag_d, &
      wavelet_o,wavelet_d,t_o,t_d,wavelet_tdelay,prop_dist)

  call mem_alloc(wavelet, wavelet_n)
  call mem_alloc(back_slow, back_lag_n)
  call mem_alloc(slow, lag_n)
  call mem_alloc(data, t_n)

  call sep_read(wavelet,"Wavelet")
  call prop_extend1D_wavelet_update2(wavelet)


  if(all_back_slow) then
    loop_trial_slow_n=back_slow_n
  else
    loop_trial_slow_n=1
  end if
   write(0,*)'loop_trial_slow_n=',loop_trial_slow_n

  do i_back_trial=1,loop_trial_slow_n
  !{
    ret_seek=sseek("in",0,0)
    ret_seek=sseek("Slow",0,0)
    trial_slow_phys=slow_o + (i_back_trial-1)*back_slow_d
    do i_slow=1,slow_n
    !{
      call sep_read(back_slow,"Slow")
      if(all_back_slow) then
        if(const_back_slow) then
          slow_phys=back_slow(back_slow_phys_lag)
        else
          slow_phys=trial_slow_phys
        end if
      else
        slow_phys=back_slow(back_slow_phys_lag)
      end if
      call prop_extend1D_back_slow_update2(slow_phys)
      if(verb) write(0,*) "i_slow=",i_slow,"slow_phy=",slow_phys
  
      if(adj) then
        call sep_read(data)
      else
        call sep_read(slow)
      end if
      call prop_extend1D_op2(adj, add, slow, data)
      if(adj) then
        call sep_write(slow)
      else
        call sep_write(data)
      end if
    !}
    end do
  !}
  end do
!---------------------------------------------------------------------------
  call system_clock(timer1)
  timer_sum = 1.*(timer1-timer0)/rate
  call to_history("timer sum (min)", timer_sum/60.)
  write(0,*) "timer sum (min)", timer_sum/60.
!---------------------------------------------------------------------------

end program
