program Prop_extend_sq

  use sep
  use mem_mod
  use prop_extend1D_mod
  use prop_extend_der11D_mod
  use Util1D_mod

  implicit none

  logical, parameter                  :: T = .true., F = .false.
  logical                             :: adj,add=F,verb,der1,random
  integer                             :: t_n,wavelet_n
  integer                             :: lag_n,slow_n,i_slow,i_lag
  integer                             :: back_lag_n,back_slow_n
  integer                             :: zero_lag,slow_phys_lag
  integer                             :: back_zero_lag,back_slow_phys_lag

  real                                :: lag_d,lag_o,slow_o,slow_d
  real                                :: back_lag_d,back_lag_o
  real                                :: back_slow_o,back_slow_d
  real                                :: wavelet_o,wavelet_d,t_o,t_d
  real                                :: wavelet_tdelay
  real                                :: slow_phys,prop_dist

  real, dimension(:), allocatable     :: slow_in,slow_out,slow_dprod
  real, dimension(:), allocatable     :: back_slow,wavelet
  real, dimension(:), allocatable     :: data

  integer(kind=8)                     :: timer0, timer1, rate
  real                                :: timer_sum

  call sep_init()

!---------------------------------------------------------------------------
  call system_clock(timer0, rate)
!---------------------------------------------------------------------------

  call from_param("der1", der1, .false.)
  call from_param("random", random, .false.)
  call get_process_param(verb,adj)
  call get_acq_param(prop_dist)
  call get_wavelet_param(wavelet_n,wavelet_o,wavelet_d,wavelet_tdelay,"in")
  call get_data_param(t_n,t_o,t_d,slow_n,slow_o,slow_d)
  call get_slow_param(lag_n,lag_o,lag_d,slow_phys_lag,zero_lag) 
  lag_n=lag_n+1
  call get_back_slow_param(back_lag_n,back_lag_o,back_lag_d, &
    back_slow_phys_lag,back_zero_lag, &
    back_slow_n,back_slow_o,back_slow_d,"Slow_back") 
  call header_to_slow_sq(lag_n-1,slow_n,lag_o,slow_o,lag_d,slow_d,"out") 
  call header_to_slow(lag_n-1,slow_n,lag_o,slow_o,lag_d,slow_d,"DotProd") 

  if(back_lag_n .ne. 1) call erexit("In Slow_back lag_n .ne. 1")
write(0,*)'slow_n=',slow_n
write(0,*)'back_slow_n=',back_slow_n
  if(slow_n .ne. back_slow_n) call erexit("slow_n .ne. back_slow_n")
  if(slow_o .ne. back_slow_o) call erexit("slow_o .ne. back_slow_o")
  if(slow_d .ne. back_slow_d) call erexit("slow_d .ne. back_slow_d")

  call prop_extend1D_init(t_n,wavelet_n,lag_n,lag_o,lag_d, &
      back_lag_n,back_lag_o,back_lag_d, &
      wavelet_o,wavelet_d,t_o,t_d,wavelet_tdelay,prop_dist)

!  if (der1) call prop_extend_der11D_init(t_n,wavelet_n,lag_n,lag_o,lag_d, &
!      back_lag_n,back_lag_o,back_lag_d, &
!      wavelet_o,wavelet_d,t_o,t_d,wavelet_tdelay,prop_dist)
  call prop_extend_der11D_init(t_n,wavelet_n,lag_n,lag_o,lag_d, &
      back_lag_n,back_lag_o,back_lag_d, &
      wavelet_o,wavelet_d,t_o,t_d,wavelet_tdelay,prop_dist)

  call mem_alloc(wavelet, wavelet_n)
  call mem_alloc(back_slow, back_lag_n)
  call mem_alloc(slow_in, lag_n-1)
  call mem_alloc(slow_out, lag_n-1)
  call mem_alloc(slow_dprod, lag_n-1)
  call mem_alloc(data, t_n)
 
  call sep_read(wavelet,"in")
  call prop_extend1D_wavelet_update2(wavelet)
!  if (der1) call prop_extend_der11D_der1_wavelet_update2(wavelet)
  call prop_extend_der11D_der1_wavelet_update2(wavelet)

  do i_slow=1,slow_n
  !{
!write(0,*)'#1'
    call sep_read(back_slow,"Slow_back")
!write(0,*)'#2'
    slow_phys=back_slow(back_lag_n)
!write(0,*)'#3'
    call prop_extend1D_back_slow_update2(slow_phys)
!    if (der1) call prop_extend_der11D_back_slow_update2(slow_phys)
    call prop_extend_der11D_back_slow_update2(slow_phys)
    if(verb) write(0,*) "i_slow=",i_slow,"slow_phy=",slow_phys

    do i_lag=1,lag_n-1
    !{
      slow_in=0
      if (random) then
        call random_seed()
        call random_number(slow_in)
      else
        slow_in(i_lag)=1
      end if
      call prop_extend1D_op2(F, F, slow_in, data)
!      call prop_extend_der11D_op2(F, F, slow_in, data)
      if (der1) then
        call prop_extend_der11D_op2(T, F, slow_out, data)
      else
        call prop_extend1D_op2(T, F, slow_out, data)
      end if
      call sep_write(slow_out)
      slow_dprod(i_lag)=dot_product(slow_in,slow_out)

    !}
    end do
    call sep_write(slow_dprod,"DotProd")

  !}
  end do
!---------------------------------------------------------------------------
  call system_clock(timer1)
  timer_sum = 1.*(timer1-timer0)/rate
  call to_history("timer sum (min)", timer_sum/60.)
  write(0,*) "timer sum (min)", timer_sum/60.
!---------------------------------------------------------------------------

end program
