module Util1D_mod

  use sep
  use mem_mod

  implicit none
  logical, private, parameter    :: T = .true., F = .false.
  integer, private, parameter    :: one = 1

!  logical, private               :: vel_extend
!  logical, private               :: GN_Hess,GN_LLAdj
!  logical, private               :: focus_slow,use_focus_oper,focus_complement
!  logical, private               :: verb
!  integer, private               :: nt,nt_wavelet,slow_n
!  integer, private               :: lag_n,zero_lag
!  integer, private               :: v_phys_lag 
!  integer, private               :: slow_phys_lag 

!  real, private                  :: dt=0., ot
!  real, private                  :: tdelay_wavelet,prop_dist
!  real, private                  :: lag_o, lag_d,slow_o,slow_d
!  real, private                  :: dt_wavelet, ot_wavelet
!  real, private                  :: slow_back_phys

!  real, dimension(:), allocatable, private         :: wavelet
!  real, dimension(:), allocatable, private         :: data_back,der1_data_back
!  real, dimension(:), allocatable, private         :: data_temp,data_temp_1
!  real, dimension(:), allocatable, private         :: data_back_sq_oper
!  real, dimension(:), allocatable, private         :: data_pert_sq_oper
!  real, dimension(:), allocatable, private         :: data_temp_sq_oper
!  real, dimension(:), allocatable, private         :: slow_temp_sq_oper
!!  real, dimension(:), allocatable, private         :: focus_slow_temp_sq_oper
!  real, dimension(:), allocatable, private         :: slow_back_conv
!
!  real, dimension(:), pointer, private             :: data_back_p
!!  real, dimension(:), pointer, private             :: data_pert_p
!  real, dimension(:), pointer, private             :: der1_data_back_p
!!  real, dimension(:), pointer, private             :: vel_conv

  contains

  subroutine get_process_param(verb,adj,add) ! get processing parameters
    logical                             :: verb,adj,add
    optional                            :: adj,add

    call from_param("verb", verb, .false.)
    if(present(adj)) call from_param("adj", adj, .false.)
    if(present(add)) call from_param("add", add, .false.)

  end subroutine

  subroutine get_back_slow_param(lag_n, lag_o,lag_d,slow_phys_lag,zero_lag, &
       slow_n,slow_o,slow_d,tag) 
    character(*), optional    :: tag
    integer                   :: lag_n,slow_phys_lag,zero_lag
    integer                   :: slow_n
    real                      :: lag_o, lag_d
    real                      :: slow_o, slow_d

    if(present(tag)) then
      call from_aux(tag,"n1", lag_n)
      call from_aux(tag,"o1", lag_o)
      call from_aux(tag,"d1", lag_d)
      call from_aux(tag,"n2", slow_n,1)
      call from_aux(tag,"o2", slow_o,0.)
      call from_aux(tag,"d2", slow_d,1.)
    else
      call from_param("n1", lag_n)
      call from_param("o1", lag_o)
      call from_param("d1", lag_d)
!write(0,*)'one='
!write(0,*)'one=',one
      call from_param("n2", slow_n,one)
!write(0,*)'slow_n=',slow_n
      call from_param("o2", slow_o,0.)
      call from_param("d2", slow_d,1.)
    end if

    if (lag_n .ne. 1) then
      slow_phys_lag=lag_n
      zero_lag=nint(-lag_o/lag_d+1) 
!write(0,*)'zero_lag=',zero_lag
      if(zero_lag < 1) call seperr("zero lag is too small")
      if(zero_lag > lag_n-1) call seperr("zero lag is too large")
!      if ((dt .ne. 0.) .and. (lag_d .ne. dt)) & 
!        call seperr("lag_d must be equal to dt_data")
    else
      slow_phys_lag=1
    end if

  end subroutine

  subroutine get_slow_param(lag_n,lag_o,lag_d,slow_phys_lag,zero_lag, &
         slow_n,slow_o,slow_d,tag) 
    character(*), optional    :: tag
    integer                   :: lag_n,slow_phys_lag,zero_lag
    integer, optional         :: slow_n
    real                      :: lag_o, lag_d
    real, optional            :: slow_o, slow_d

    if(present(tag)) then
      call from_aux(tag,"n1", lag_n)
      call from_aux(tag,"o1", lag_o)
      call from_aux(tag,"d1", lag_d)
      call from_aux(tag,"n2", slow_n,1)
      call from_aux(tag,"o2", slow_o,0.)
      call from_aux(tag,"d2", slow_d,1.)
    else
      call from_param("lag_n", lag_n)
      call from_param("lag_o", lag_o)
      call from_param("lag_d", lag_d)
!write(0,*)'one=',one
!      call from_param("n2", slow_n,one)
!write(0,*)'slow_n=',slow_n
!      call from_param("slow_n", slow_n,1)
!      call from_param("slow_o", slow_o,0.)
!      call from_param("slow_d", slow_d,1.)
    end if

    if (lag_n .ne. 1) then
      slow_phys_lag=lag_n
      zero_lag=nint(-lag_o/lag_d+1) 
!write(0,*)'zero_lag=',zero_lag
      if(zero_lag < 1) call seperr("zero lag is too small")
      if(zero_lag > lag_n-1) call seperr("zero lag is too large")
!      if ((dt .ne. 0.) .and. (lag_d .ne. dt)) & 
!        call seperr("lag_d must be equal to dt_data")
    else
      slow_phys_lag=1
    end if

  end subroutine

!  subroutine check_model_param(tag,lag_n_in, lag_o_in,lag_d_in, &
!        slow_n,slow_o_in,slow_d_in) 
!    character(*)                   :: tag
!    integer                        :: lag_n_in
!    integer                        :: slow_n
!    real                           :: lag_o_in, lag_d_in
!    real                           :: slow_o_in,slow_d_in
!
!    integer                        :: lag_n
!    integer                        :: slow_n
!    real                           :: lag_o, lag_d
!    real                           :: slow_o,slow_d

!    call from_aux(tag,"n1", lag_n)
!    call from_aux(tag,"o1", lag_o)
!    call from_aux(tag,"d1", lag_d)
!
!    if(lag_n .ne. lag_n_in) call seperr("lag_n /= lag_n_in in slow_pert")
!    if(lag_o .ne. lag_o_in) call seperr("lag_o /= lag_o_in in slow_pert")
!    if(lag_d .ne. lag_d_in) call seperr("lag_d /= lag_d_in in slow_pert")
!
!    call from_aux(tag,"n2", slow_n)
!    call from_aux(tag,"o2", slow_o)
!    call from_aux(tag,"d2", slow_d)
!
!    if(n_slow .ne. n_slow_in) call seperr("n_slow /= n_slow_in in slow_pert")
!    if(slow_o .ne. slow_o) call seperr("slow_o /= slow_o in slow_pert")
!    if(slow_d .ne. slow_d_in) call seperr("slow_d /= slow_d_in in slow_pert")
!
!  end subroutine

  subroutine get_wavelet_param(wavelet_n,wavelet_o,wavelet_d,wavelet_tdelay,tag)
    character(*), optional    :: tag
    integer                             :: wavelet_n
    real                                :: wavelet_o,wavelet_d
    real                                :: wavelet_tdelay

!    if(exist_file(tag)) then
    if(present(tag)) then
      call from_aux(tag, "n1", wavelet_n)
      call from_aux(tag, "o1", wavelet_o)
      call from_aux(tag, "d1", wavelet_d)
      call from_aux(tag, "tdelay", wavelet_tdelay)
    else
      call from_param("nt_wavelet", wavelet_n)
      call from_param("ot_wavelet", wavelet_o,0.)
      call from_param("dt_wavelet", wavelet_d)
      call from_param("tdelay_wavelet", wavelet_tdelay)
    end if

!    nt_wavelet_out = nt_wavelet
!    if(present(ot_wavelet_out)) ot_wavelet_out = ot_wavelet
!    if(present(dt_wavelet_out)) dt_wavelet_out = dt_wavelet
!    if(present(tdelay_wavelet_out)) tdelay_wavelet_out = tdelay_wavelet

  end subroutine

  subroutine get_acq_param(prop_dist)
    real                             :: prop_dist
    call from_param("prop_dist", prop_dist)
  end subroutine

  subroutine get_data_param(t_n,t_o,t_d,slow_n,slow_o,slow_d,tag)
    character(*), optional    :: tag
    integer                   :: t_n
    real                      :: t_o, t_d
    integer, optional          :: slow_n
    real, optional             :: slow_o, slow_d

!    if(exist_file(tag)) then
    if(present(tag)) then
      call from_aux(tag, "n1", t_n)
      call from_aux(tag, "o1", t_o)
      call from_aux(tag, "d1", t_d)
      if(.not. present(slow_n)) call seperr ("Missing parameter slow_n in get_data_param")
      call from_aux(tag,"n2", slow_n,1)
      call from_aux(tag,"o2", slow_o,0.)
      call from_aux(tag,"d2", slow_d,1.)
    else
      call from_param("nt", t_n)
      call from_param("ot", t_o)
      call from_param("dt", t_d)
      if(present(slow_n)) then
        call from_param("slow_n", slow_n,1)
        call from_param("slow_o", slow_o,0.)
        call from_param("slow_d", slow_d,1.)
      end if
    end if

!    nt_out = nt
!    if(present(ot_out)) ot_out = ot
!    if(present(dt_out)) dt_out = dt

  end subroutine

  subroutine get_focus_oper_param(focus_oper_n,focus_oper_o,focus_oper_d,tag)
    character(*), optional    :: tag
    integer                   :: focus_oper_n
    real                      :: focus_oper_o, focus_oper_d

    if(present(tag)) then
      call from_aux(tag,"n2", focus_oper_n,1)
      call from_aux(tag,"o2", focus_oper_o,0.)
      call from_aux(tag,"d2", focus_oper_d,1.)
    else
      call from_param("focus_oper_n", focus_oper_n,1)
      call from_param("focus_oper_o", focus_oper_o,0.)
      call from_param("focus_oper_d", focus_oper_d,1.)
    end if

  end subroutine

  subroutine header_to_slow(lag_n,slow_n,lag_o,slow_o,lag_d,slow_d,tag) 
    character(*)    :: tag
    integer                             :: lag_n,slow_n
    real                                :: lag_o, lag_d
    real                                :: slow_o, slow_d

    call to_history("n1", lag_n, tag)
    call to_history("o1", lag_o, tag)
    call to_history("d1", lag_d, tag)
    call to_history("label1", "lag (s)", tag)
    call to_history("n2", slow_n, tag)
    call to_history("o2", slow_o, tag)
    call to_history("d2", slow_d, tag)
    call to_history("label2", "Slowness (s/km)", tag)
  end subroutine

  subroutine header_to_slow_sq(lag_n,slow_n,lag_o,slow_o,lag_d,slow_d,tag) 
    character(*)    :: tag
    integer                             :: lag_n,slow_n
    real                                :: lag_o, lag_d
    real                                :: slow_o, slow_d

    call to_history("n1", lag_n, tag)
    call to_history("o1", lag_o, tag)
    call to_history("d1", lag_d, tag)
    call to_history("label1", "lag (s)", tag)
    call to_history("n2", lag_n, tag)
    call to_history("o2", lag_o, tag)
    call to_history("d2", lag_d, tag)
    call to_history("label2", "lag (s)", tag)
    call to_history("n3", slow_n, tag)
    call to_history("o3", slow_o, tag)
    call to_history("d3", slow_d, tag)
    call to_history("label3", "Slowness (s/km)", tag)
  end subroutine

  subroutine header_to_data(t_n,slow_n,t_o,slow_o,t_d,slow_d,tag) 
    character(*)    :: tag
    integer                   :: t_n,slow_n
    real                      :: t_o, t_d,slow_o,slow_d

    call to_history("n1", t_n, tag)
!    call to_history("o1", ot-tdelay_wavelet, tag)
    call to_history("o1", t_o, tag)
    call to_history("d1", t_d, tag)
    call to_history("label1", "Time (s)", tag)
    call to_history("n2", slow_n, tag)
    call to_history("o2", slow_o, tag)
    call to_history("d2", slow_d, tag)
    call to_history("label2", "Slowness (s/km)", tag)
  end subroutine

  subroutine header_to_wavelet(wavelet_n,slow_n,wavelet_o,slow_o,wavelet_d,slow_d,tag) 
    character(*)    :: tag
    integer                   :: wavelet_n,slow_n
    real                      :: wavelet_o, wavelet_d,slow_o,slow_d

    call to_history("n1", wavelet_n, tag)
    call to_history("o1", wavelet_o, tag)
    call to_history("d1", wavelet_d, tag)
    call to_history("label1", "Time (s)", tag)
    call to_history("n2", slow_n, tag)
    call to_history("o2", slow_o, tag)
    call to_history("d2", slow_d, tag)
    call to_history("label2", "Slowness (s/km)", tag)
  end subroutine

end module
