module focus1Daxis_mod
  use sep
  use axis_mod
  use mem_mod
  use adj_mod

  implicit none
  logical, private, parameter   :: T = .true., F = .false.
  type(axis)                    :: caxis
  logical, private              :: use_foc,foc_comp
  integer, private              :: lag_n,zlag,plag
  real, private                 :: lag_o,lag_d

  real, dimension(:), allocatable, private         :: focus_oper

  contains

  subroutine focus1Daxis_init(verb_in, use_foc_in, foc_comp_in, caxis_in, zlag_in)

    logical    :: verb_in,use_foc_in,foc_comp_in
    integer    :: zlag_in
    type(axis) :: caxis_in

    use_foc  = use_foc_in
    foc_comp = foc_comp_in
    caxis    = caxis_in
    zlag     = zlag_in

    lag_n = caxis%n; lag_o = caxis%o; lag_d = caxis%d
    plag  = caxis%n

    if(use_foc) then
      call mem_alloc(focus_oper, caxis%n)
      call sep_read(focus_oper, "focus_oper")
    end if
  end subroutine

  integer function focus1Daxis_op(adj, add, model, data)
    logical             :: adj, add
    real, dimension(:)  :: model, data
    call focus1Daxis_op2(adj, add, model, data)
    focus1Daxis_op = 0
  end function

  subroutine focus1Daxis_op2(adj, add, model, data) 
    logical             :: adj, add
    real, dimension(:)  :: model, data

    call adjnull (adj,add,model,data )

    if(add) call seperr("focus_1D not implemeted with add=y")
    if(adj) then
      if(use_foc) then
        model = data * focus_oper
      else
        model(1:zlag - 2)        = data(2:zlag - 1)
        model(zlag - 1)          = 0.
        model(zlag)              = data(zlag)
        model(zlag + 1)          = 0.
        model(zlag + 2:plag - 1) = data(zlag + 1:plag - 2)
        model(plag)=data(plag)
      end if
      if(foc_comp) then
        model(1:plag - 1)= data(1:plag - 1)-model(1:plag - 1)
      endif
    else
      if(use_foc) then
        data= model * focus_oper
      else
        data(1)                 = 0.
        data(2:zlag - 1)        = model(1:zlag - 2)
        data(zlag)              = model(zlag)
        data(zlag + 1:plag - 2) = model(zlag + 2:plag - 1)
        data(plag)              = model(plag)
      end if
      if(foc_comp) then
        data(1:plag - 1) = model(1:plag - 1)-data(1:plag - 1)
      endif
    end if
  end subroutine

end module
