! implementation of script-L in notes
module prop1D_mod

  use mem_mod
  use adj_mod
  use lint1_stat  

  implicit none

  logical, private, parameter                      :: T = .true., F = .false.

  integer, private                              :: t_n,wavelet_n,lag_n,zero_lag
  real, private                                 :: lag_o,lag_d,prop_dist
  real, private                                 :: wavelet_o,wavelet_d,t_o,t_d
  real, private                                 :: wavelet_tdelay
  real, private                                 :: slow_phys


  contains

  subroutine prop1D_init(t_n_in,wavelet_n_in,lag_n_in,lag_o_in,lag_d_in, &
      wavelet_o_in,wavelet_d_in,t_o_in,t_d_in,wavelet_tdelay_in,prop_dist_in)
    integer                        :: t_n_in,wavelet_n_in,lag_n_in
    real                           :: lag_o_in,lag_d_in,prop_dist_in
    real                           :: wavelet_o_in,wavelet_d_in,t_o_in,t_d_in
    real                           :: wavelet_tdelay_in

    t_n = t_n_in
    wavelet_n = wavelet_n_in
    lag_n = lag_n_in
    lag_o = lag_o_in
    lag_d = lag_d_in
    wavelet_o=wavelet_o_in
    wavelet_d=wavelet_d_in
    t_o=t_o_in
    t_d=t_d_in
    wavelet_tdelay=wavelet_tdelay_in
    prop_dist = prop_dist_in

    if (wavelet_d .ne. t_d) then
      write(0,*)'t_d=',t_d
      write(0,*)'wavelet_d=',wavelet_d
      call seperr("wavelet_d must be equal to t_d_data")
    end if

  end subroutine

  integer function prop1D_slow_update(slow_phys_in)
    real                :: slow_phys_in
    call prop1D_slow_update2(slow_phys_in)
    prop1D_slow_update = 0
  end function

  subroutine prop1D_slow_update2(slow_phys_in)
    real                :: slow_phys_in

    slow_phys = slow_phys_in
  end subroutine


  integer function prop1D_op(adj, add, model, data)
    logical            :: adj, add
    real,dimension(:)  :: model, data
    call prop1D_op2(adj, add, model, data)
    prop1D_op = 0
  end function

  subroutine prop1D_op2(adj, add, model, data)
    logical                   :: adj, add
    real, dimension(:) :: model, data

    real                   :: time_prop

    call adjnull (adj,add,model,data )

    if(adj) then
      time_prop=(prop_dist*slow_phys)-(wavelet_tdelay+t_o)
      call lint1_stat_init (wavelet_o,t_d,-time_prop)
      call lint1_stat_lop2 (T,add, model, data)
    else
      time_prop=(prop_dist*slow_phys)-(wavelet_tdelay+t_o)
      call lint1_stat_init (wavelet_o,t_d,-time_prop)
      call lint1_stat_lop2 (F,add, model, data)
    end if
  end subroutine

end module
