module tcai1_nb  
!  use sep_mod
! Transient Convolution Adjoint Input 1-D. yy(m1+n1)
  use adj_mod
  implicit none
  real ,private,  dimension (:), pointer  :: bb 
  contains
  subroutine tcai1_nb_init ( bb_in )
    real ,   dimension (:), pointer :: bb_in 
    bb => bb_in
!write(0,*)'shape(bb)=',shape(bb)
!write(0,*)'shape(bb_in)=',shape(bb_in)
!    write(0,*)'In init: size(bb)=',size(bb)
  end subroutine
  function tcai1_nb_lop ( adj, add, xx, yy) result(stat)
    integer            :: stat 
    logical,intent(in) :: adj,add 
    real,dimension(:)  :: xx,yy 
    call tcai1_nb_lop2(adj,add,xx,yy )
    stat=0
  end function 
  subroutine tcai1_nb_lop2(adj,add,xx,yy)
    logical,intent(in) :: adj,add 
    real, dimension (:)  :: xx 
    real, dimension (:)  :: yy 
    integer b, x, y

    call adjnull (adj,add,xx,yy )

!    write(0,*)'size(yy)=',size(yy)
!    write(0,*)'size(xx)=',size(xx)
!    write(0,*)'size(bb)=',size(bb)

!    if ( size(yy) < size (xx) + size(bb) - 1 ) then
!      call erexit('tcai: n_model + n_filter > n_data')
!    end if
    do b= 1, size(bb)
      do x= 1, min(size(xx),size(yy)-b+1)
        y = x + b - 1
        if ( adj) then
          xx(x) =        xx(x) +  yy(y) * bb(b)
        else
          yy(y) =                 yy(y) +  xx(x) * bb(b)
        end if
      end do
    end do
  end subroutine 
  subroutine tcai1_nb_close()
  end subroutine 
end module 
