% c must be column vector of size 2*N-1
% dr must be column vector of size N
% grad_s is a scalar
% grad_c is a column vector of size 2*N-1

function [grad_s,grad_c] = J0_grad(s,c,l,alpha,dt,dr)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Estimate N (number of samples)

N = size(c);
N = (N(1,1) + 1)/2;
%//////////////////////////////////////////////////////////////////////////

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calculate ltilda and ltilda_grad

[data,d] = ltilda(s,c,l,alpha,dt);
data_grad = ltilda_grad(s,c,l,alpha,dt);
%//////////////////////////////////////////////////////////////////////////

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calculate grad_s

grad_s = data_grad' * (data - dr);
%//////////////////////////////////////////////////////////////////////////

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calculate grad_c

grad_c = zeros(1,2*N-1);
res = data - dr;

temp = wrev(d');
temp1 = zeros(1,2*N-1);
for i = 1:N
    temp1 = temp1*0;
    temp1(1,i:i+N-1) = temp;
    grad_c = grad_c + res(i,1)*temp1;
end

grad_c = grad_c';
%//////////////////////////////////////////////////////////////////////////

return;

end