close all

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Set parameters

s_bar = 0.001;
s0 = [0.0002:0.00001:0.0019]';
ds0 = s0(2,1) - s0(1,1);
n1 = 10; % Number of perturbations in each direction about s0
ds = 0.000001;
%//////////////////////////////////////////////////////////////////////////

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot all objectives

i = 50;
S0 = s0(1,1) + (i-1)*ds0;
S = ([S0-n1*ds:2*ds:S0+n1*ds] - S0)*1000;

f1 = figure('units','normalized','outerposition',[0 0 1 1]);
plot(objscan1(i,:),'-bo','LineWidth',2,'MarkerFaceColor','r','MarkerEdgeColor','r');
grid on;
hold on;
plot(objscan2(i,:),'-blacko','LineWidth',2,'MarkerFaceColor','r','MarkerEdgeColor','r');
plot(objscan(i,:),'-ro','LineWidth',2,'MarkerFaceColor','black','MarkerEdgeColor','black');
str = sprintf('s_0 = %4.3f ms/m',S0*1000);
title(str,'Fontsize',15);
ylabel('J_+(s), J_-(s), J_+(s) J_-(s)','Fontsize',15);
xlabel('Slowness perturbation \Deltas (ms/m)','Fontsize',15);
xlim([1 21]);
ylim([0 1e4]);
set(gca,'XTick',1:2:21)
set(gca,'XTickLabel',S)
f1_leg = legend('J_+(s)', 'J_-(s)', 'J_+(s) + J_-(s)');
set(f1_leg,'FontSize',15);
print('rahulfig_test/Jm-50','-depsc')
%//////////////////////////////////////////////////////////////////////////

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot all objectives

i = 110;
S0 = s0(1,1) + (i-1)*ds0;
S = ([S0-n1*ds:2*ds:S0+n1*ds] - S0)*1000;

f1 = figure('units','normalized','outerposition',[0 0 1 1]);
plot(objscan1(i,:),'-bo','LineWidth',2,'MarkerFaceColor','r','MarkerEdgeColor','r');
grid on;
hold on;
plot(objscan2(i,:),'-blacko','LineWidth',2,'MarkerFaceColor','r','MarkerEdgeColor','r');
plot(objscan(i,:),'-ro','LineWidth',2,'MarkerFaceColor','black','MarkerEdgeColor','black');
str = sprintf('s_0 = %4.3f ms/m',S0*1000);
title(str,'Fontsize',15);
ylabel('J_+(s), J_-(s), J_+(s) J_-(s)','Fontsize',15);
xlabel('Slowness perturbation \Deltas (ms/m)','Fontsize',15);
xlim([1 21]);
ylim([0 1e4]);
set(gca,'XTick',1:2:21)
set(gca,'XTickLabel',S)
f1_leg = legend('J_+(s)', 'J_-(s)', 'J_+(s) + J_-(s)');
set(f1_leg,'FontSize',15);
print('rahulfig_test/Jm-110','-depsc')
%//////////////////////////////////////////////////////////////////////////

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot all objectives

i = 80;
S0 = s0(1,1) + (i-1)*ds0;
S = ([S0-n1*ds:2*ds:S0+n1*ds] - S0)*1000;

f1 = figure('units','normalized','outerposition',[0 0 1 1]);
plot(objscan1(i,:),'-bo','LineWidth',2,'MarkerFaceColor','r','MarkerEdgeColor','r');
grid on;
hold on;
plot(objscan2(i,:),'-blacko','LineWidth',2,'MarkerFaceColor','r','MarkerEdgeColor','r');
plot(objscan(i,:),'-ro','LineWidth',2,'MarkerFaceColor','black','MarkerEdgeColor','black');
str = sprintf('s_0 = %4.3f ms/m',S0*1000);
title(str,'Fontsize',15);
ylabel('J_+(s), J_-(s), J_+(s) J_-(s)','Fontsize',15);
xlabel('Slowness perturbation \Deltas (ms/m)','Fontsize',15);
xlim([1 21]);
ylim([0 1e4]);
set(gca,'XTick',1:2:21)
set(gca,'XTickLabel',S)
f1_leg = legend('J_+(s)', 'J_-(s)', 'J_+(s) + J_-(s)');
set(f1_leg,'FontSize',15);
print('rahulfig_test/Jm-80','-depsc')
%//////////////////////////////////////////////////////////////////////////

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot all objectives

i = 82;
S0 = s0(1,1) + (i-1)*ds0;
S = ([S0-n1*ds:2*ds:S0+n1*ds] - S0)*1000;

f1 = figure('units','normalized','outerposition',[0 0 1 1]);
plot(objscan1(i,:),'-bo','LineWidth',2,'MarkerFaceColor','r','MarkerEdgeColor','r');
grid on;
hold on;
plot(objscan2(i,:),'-blacko','LineWidth',2,'MarkerFaceColor','r','MarkerEdgeColor','r');
plot(objscan(i,:),'-ro','LineWidth',2,'MarkerFaceColor','black','MarkerEdgeColor','black');
str = sprintf('s_0 = %4.3f ms/m',S0*1000);
title(str,'Fontsize',15);
ylabel('J_+(s), J_-(s), J_+(s) J_-(s)','Fontsize',15);
xlabel('Slowness perturbation \Deltas (ms/m)','Fontsize',15);
xlim([1 21]);
ylim([0 1e4]);
set(gca,'XTick',1:2:21)
set(gca,'XTickLabel',S)
f1_leg = legend('J_+(s)', 'J_-(s)', 'J_+(s) + J_-(s)');
set(f1_leg,'FontSize',15);
print('rahulfig_test/Jm-82','-depsc')
%//////////////////////////////////////////////////////////////////////////

close all