close all

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Set parameters

N = 5;
%//////////////////////////////////////////////////////////////////////////

c = [0;1;2;3;4;3;2;1;0];
idx = [1-N:1:N-1]';

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot chat

f1 = figure('units','normalized','outerposition',[0 0 1 1]);
stem(idx,c,'-bo','LineWidth',2,'MarkerFaceColor','r','MarkerEdgeColor','r','MarkerSize',15);
hold on;
title('c','Fontsize',15);
ylabel('Amplitude','Fontsize',15);
xlabel('Lag coefficient','Fontsize',15);
ylim([0 5]);
print('rahulfig_test/C','-depsc')
%//////////////////////////////////////////////////////////////////////////

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot S+ chat

spc = Fshift(c,1);
f1 = figure('units','normalized','outerposition',[0 0 1 1]);
stem(idx,spc,'-bo','LineWidth',2,'MarkerFaceColor','r','MarkerEdgeColor','r','MarkerSize',15);
hold on;
title('S_+c','Fontsize',15);
ylabel('Amplitude','Fontsize',15);
xlabel('Lag coefficient','Fontsize',15);
ylim([0 5]);
print('rahulfig_test/SpC','-depsc')
%//////////////////////////////////////////////////////////////////////////

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot S- chat

smc = Fshift(c,-1);
f1 = figure('units','normalized','outerposition',[0 0 1 1]);
stem(idx,smc,'-bo','LineWidth',2,'MarkerFaceColor','r','MarkerEdgeColor','r','MarkerSize',15);
hold on;
title('S_-c','Fontsize',15);
ylabel('Amplitude','Fontsize',15);
xlabel('Lag coefficient','Fontsize',15);
ylim([0 5]);
print('rahulfig_test/SmC','-depsc')
%//////////////////////////////////////////////////////////////////////////

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot M0 S+ chat

c1 = Fmask(spc,N,0);
f1 = figure('units','normalized','outerposition',[0 0 1 1]);
stem(idx,c1,'-bo','LineWidth',2,'MarkerFaceColor','r','MarkerEdgeColor','r','MarkerSize',15);
hold on;
title('M_0S_+c','Fontsize',15);
ylabel('Amplitude','Fontsize',15);
xlabel('Lag coefficient','Fontsize',15);
ylim([0 5]);
print('rahulfig_test/C1','-depsc')
%//////////////////////////////////////////////////////////////////////////

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot M-1 chat

c2 = Fmask(c,N-1,0);
f1 = figure('units','normalized','outerposition',[0 0 1 1]);
stem(idx,c2,'-bo','LineWidth',2,'MarkerFaceColor','r','MarkerEdgeColor','r','MarkerSize',15);
hold on;
title('M_{-1}c','Fontsize',15);
ylabel('Amplitude','Fontsize',15);
xlabel('Lag coefficient','Fontsize',15);
ylim([0 5]);
print('rahulfig_test/C2','-depsc')
%//////////////////////////////////////////////////////////////////////////

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot (I-M-1) S- chat

c3 = Fmask(smc,N-1,1);
f1 = figure('units','normalized','outerposition',[0 0 1 1]);
stem(idx,c3,'-bo','LineWidth',2,'MarkerFaceColor','r','MarkerEdgeColor','r','MarkerSize',15);
hold on;
title('[I-M_{-1}]S_-c','Fontsize',15);
ylabel('Amplitude','Fontsize',15);
xlabel('Lag coefficient','Fontsize',15);
ylim([0 5]);
print('rahulfig_test/C3','-depsc')
%//////////////////////////////////////////////////////////////////////////

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot (I-M0) chat

c4 = Fmask(c,N,1);
f1 = figure('units','normalized','outerposition',[0 0 1 1]);
stem(idx,c4,'-bo','LineWidth',2,'MarkerFaceColor','r','MarkerEdgeColor','r','MarkerSize',15);
hold on;
title('[I-M_0]c','Fontsize',15);
ylabel('Amplitude','Fontsize',15);
xlabel('Lag coefficient','Fontsize',15);
ylim([0 5]);
print('rahulfig_test/C4','-depsc')
%//////////////////////////////////////////////////////////////////////////

close all
