close all

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Set parameters

s_bar = 0.001;
s0 = [0.0002:0.00001:0.0019]';
ds0 = s0(2,1) - s0(1,1);
n1 = 10; % Number of perturbations in each direction about s0
ds = 0.000001;
%//////////////////////////////////////////////////////////////////////////

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot ||v||^2_2

i = 50;
S0 = s0(1,1) + (i-1)*ds0;
S = ([S0-n1*ds:2*ds:S0+n1*ds] - S0)*1000;

f1 = figure('units','normalized','outerposition',[0 0 1 1]);
plot(objscan1(i,:),'-bo','LineWidth',2,'MarkerFaceColor','r','MarkerEdgeColor','r');
grid on;
hold on;
str = sprintf('s_0 = %4.3f ms/m',S0*1000);
title(str,'Fontsize',15);
ylabel('0.5 ||v(s_0 + \Deltas)||^2_2','Fontsize',15);
xlabel('Slowness perturbation \Deltas (ms/m)','Fontsize',15);
xlim([1 21]);
set(gca,'XTick',1:2:21)
set(gca,'XTickLabel',S)
f1_leg = legend('0.5 ||v||^2_2');
set(f1_leg,'FontSize',15);
print('rahulfig_test/V-50','-depsc')
%//////////////////////////////////////////////////////////////////////////

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot ||v||^2_2

i = 110;
S0 = s0(1,1) + (i-1)*ds0;
S = ([S0-n1*ds:2*ds:S0+n1*ds] - S0)*1000;

f1 = figure('units','normalized','outerposition',[0 0 1 1]);
plot(objscan1(i,:),'-bo','LineWidth',2,'MarkerFaceColor','r','MarkerEdgeColor','r');
grid on;
hold on;
str = sprintf('s_0 = %4.3f ms/m',S0*1000);
title(str,'Fontsize',15);
ylabel('0.5 ||v(s_0 + \Deltas)||^2_2','Fontsize',15);
xlabel('Slowness perturbation \Deltas (ms/m)','Fontsize',15);
xlim([1 21]);
set(gca,'XTick',1:2:21)
set(gca,'XTickLabel',S)
f1_leg = legend('0.5 ||v||^2_2');
set(f1_leg,'FontSize',15);
print('rahulfig_test/V-110','-depsc')
%//////////////////////////////////////////////////////////////////////////

close all