clc
clear all
close all

disp('Computing results')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Set parameters and model some data
alpha = 25;
N = 1001;
dt = 0.008;
l = 4000;
s_bar = 0.001;
delay = l*s_bar;

[dr,t] = ricker(alpha,N,dt,delay);
%//////////////////////////////////////////////////////////////////////////

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Perform scan

% Define c0 = 0
c0 = zeros(2*N-1,1);

% Array of starting models
s0 = 0.0002:0.00001:0.0019;
s0 = s0';
n = size(s0);
n = n(1,1);

% Array of models for scan
n1 = 10; % Number of perturbations in each direction about s0
ds = 0.000001;
s = zeros(n,2*n1+1);
for i=1:n
    for j=1:(2*n1+1)
        s(i,j) = s0(i,1) + ds*(j - n1 - 1);
    end
end

% Allocate array to store the obj scan
objscan = zeros(n,n1);

for i=1:n
    
    [grad_s,grad_c] = J0_grad(s0(i,1),c0,l,alpha,dt,dr);
    t1 = ltilda(s0(i,1),-grad_c,l,alpha,dt);
    
    Fgrad_c = Ffocus(grad_c);
    
    for j=1:(2*n1+1)
        t2 = ltilda(s(i,j),-Fgrad_c,l,alpha,dt);
        objscan(i,j) = (t1 - t2)'*(t1 - t2);
    end
    
end
%//////////////////////////////////////////////////////////////////////////

disp('Finished computing')



