% c must be column vector of size 2*N-1

function [data,d,conv] = ltilda_grad(s,c,l,alpha,dt)

% Estimate N (number of samples)
N = size(c);
N = (N(1,1) + 1)/2;

% Generate ricker wavelet derivative for a given slowness s
delay = l*s;
d = (-l)*ricker_derivative(alpha,N,dt,delay);

% Perform convolution
conv = zeros(N,1);
for i = 1:N
    temp = wrev(c(i:i+N-1,1));
    conv(i,1) = temp'*d;
end

% Add the results
data = d + conv;

return;

end